from w.services.technical.backends.encryption.fake_encryption_backend import (
    FakeEncryptionBackend,
)
from w.services.technical.encryption_service import EncryptionService
from w.tests.mixins.testcase_mixin import TestCaseMixin


class TestEnCryptionService(TestCaseMixin):
    @classmethod
    def setup_class(cls):
        super().setup_class()
        cls.to_encrypt = "ma chaine à crypter"

    def setup_method(self):
        EncryptionService.set_backend(FakeEncryptionBackend)

    """
    encrypt/decrypt
    """

    def test_encrypt_decrypt_with_success_return_str(self):
        crypted = EncryptionService.encrypt(self.to_encrypt)
        actual = EncryptionService.decrypt(crypted)
        assert actual != crypted
        assert actual == self.to_encrypt
