from django.test import override_settings

from w.services.technical.hasher_service import HasherService
from w.tests.mixins.testcase_mixin import TestCaseMixin


class TestHasherService(TestCaseMixin):
    @classmethod
    def setup_class(cls):
        super().setup_class()
        cls.to_hash = "ma chaine à hacher"

    """
    argon2_hash
    """

    def test_argon2_hash_with_success_return_str(self):
        actual = HasherService.argon2_hash(self.to_hash)
        assert "$argon2id$v=19$m=65536" in actual

    """
    blake2_backend
    """

    @override_settings(HASH_SECRET_KEY="secret-key-should-be-32bits")
    def test_blake2_backend_with_success_return_str(self):
        actual = HasherService.blake2_hash(self.to_hash)
        assert "4a63ef4171bfd732cc961585faa954a00f77b0b09323444" in actual
